//+------------------------------------------------------------------+
//|                                                         KAMA.mq4 |
//|                                    Copyright? 2009, Walter Choy. |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "Copyright? 2009, Walter Choy."
#property link      ""

#property indicator_chart_window
#property indicator_buffers 1
#property indicator_color1 Red

//---- input parameters
input ENUM_APPLIED_PRICE inpPrice      = PRICE_CLOSE; // Price
extern int       kama_period = 10;
extern double    fast_ma_period = 2.0;
extern double    slow_ma_period = 30.0;
//---- buffers
double KAMA[],prices[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
  IndicatorBuffers(2);
//---- indicators
   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(0,KAMA,INDICATOR_DATA);
   SetIndexBuffer(1,prices,INDICATOR_CALCULATIONS);
   SetIndexLabel(0, "SQKAMAOhlc");
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int    counted_bars=IndicatorCounted();
//----
   int i = Bars - counted_bars;
   
   double fastest = 2 / (fast_ma_period + 1);
   double slowest = 2 / (slow_ma_period + 1);
   
   while(i>0){
   
   
      prices[i] = iMA(NULL,0,1,0,MODE_SMA,inpPrice,i);
      double er = 1;
      double signal = MathAbs(prices[i] - prices[i+kama_period]);
      double noise = 0;
      //double price = 
      for (int j=0; j<kama_period; j++)
         noise += MathAbs(prices[i+j] - prices[i+j+1]);
      if (noise > 0)
         er = signal / noise;
      double sc = MathPow((er * (fastest - slowest) + slowest), 2);
      KAMA[i] = KAMA[i+1] + sc * (prices[i] - KAMA[i+1]);
      
      
     
      
      i--;
   }
//----
   return(0);
  }
//+------------------------------------------------------------------+